<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>問題6.14 - 外力を受けた減衰振り子 &mdash; 計算機実習2014</title>
    
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '1.0',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/translations.js"></script>
    <link rel="author" title="このドキュメントについて" href="../about.html" />
    <link rel="top" title="計算機実習2014" href="../index.html" />
    <link rel="next" title="問題6.16 - 標準写像" href="../6-16_standard_map/6-16.html" />
    <link rel="prev" title="問題6.12 - エノン写像" href="../6-12_henon/6-12.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="../6-16_standard_map/6-16.html" title="問題6.16 - 標準写像"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="../6-12_henon/6-12.html" title="問題6.12 - エノン写像"
             accesskey="P">前へ</a> |</li>
        <li><a href="../index.html">計算機実習2014</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="label">
<span id="id1"></span><h1><a class="toc-backref" href="#id7">問題6.14 - 外力を受けた減衰振り子</a><a class="headerlink" href="#label" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="contents topic" id="contents">
<p class="topic-title first">Contents</p>
<ul class="simple">
<li><a class="reference internal" href="#label" id="id7">問題6.14 - 外力を受けた減衰振り子</a><ul>
<li><a class="reference internal" href="#id2" id="id8">シミュレーションの目的</a></li>
<li><a class="reference internal" href="#id3" id="id9">作成したプログラム</a></li>
<li><a class="reference internal" href="#id4" id="id10">実習課題</a></li>
<li><a class="reference internal" href="#id5" id="id11">まとめ</a></li>
<li><a class="reference internal" href="#id6" id="id12">参考文献</a></li>
</ul>
</li>
</ul>
</div>
<div class="section" id="id2">
<h2><a class="toc-backref" href="#id8">シミュレーションの目的</a><a class="headerlink" href="#id2" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>古典力学で記述される非線形力学系のよく知られた例である単振り子について、一次の減衰項があって、振り子の支点が垂直方向に動かされる場合を考えよう。この系に対するニュートンの第2法則は</p>
<div class="math" id="equation-e1">
<p><span class="eqno">(1)</span><img src="../_images/math/990b8c801b52109343c4d61834d6493d3be54df0.png" alt="\frac{ d^{2}\theta }{ dt^{2} } = -\gamma \frac{ d\theta }{dt}-[\omega_{0}^{2} + 2A \cos \omega t]\sin \theta"/></p>
</div><p>と書き表される。ここで<img class="math" src="../_images/math/a9cfbeb8ebee1f365919e147a79e242dcb67ee5d.png" alt="\theta"/>は振り子が鉛直軸となす角度、<img class="math" src="../_images/math/0ebb67342b546ca42a1c634b1ef03c893c4cdedb.png" alt="\gamma"/>は減衰定数、<img class="math" src="../_images/math/950f45a362201476bb3512ed5910d37a9765678e.png" alt="\omega_{0}^{2}=g/L"/>は振り子の自然振動数、<img class="math" src="../_images/math/c7415c6919c2eb17b1ea36f0243079b59825ee89.png" alt="\omega"/>と<img class="math" src="../_images/math/0acafa529182e79b4f56165ec677554fba7fcf98.png" alt="A"/>はそれぞれ外力の振動数と振幅である。支点を垂直方向に加速することは時間に依存する重力場を考えることと等価である。
この外力を受けた減衰のある単振り子はどのように振る舞うと予想されるか。減衰項が存在するために、外力がないときには振り子は静止してしまう。つまり、(<img class="math" src="../_images/math/55ba271999995cac02cf578362df5be030594ed6.png" alt="x=0"/>、<img class="math" src="../_images/math/c99c34dbd3d8e874a8ea4cc301e3b8ff9abcea59.png" alt="y=0"/>)は安定なアトラクタである。<img class="math" src="../_images/math/0acafa529182e79b4f56165ec677554fba7fcf98.png" alt="A"/>を0から大きくしていくとき、小さな<img class="math" src="../_images/math/0acafa529182e79b4f56165ec677554fba7fcf98.png" alt="A"/>に対してはこのアトラクタは安定である。しかし、<img class="math" src="../_images/math/0acafa529182e79b4f56165ec677554fba7fcf98.png" alt="A"/>がある値<img class="math" src="../_images/math/0ef376004ce4398fcb1e755c0787ead2b79e281a.png" alt="\mathrm{A}_{c}"/>を超えると、このアトラクタは不安定となる。振幅<img class="math" src="../_images/math/0acafa529182e79b4f56165ec677554fba7fcf98.png" alt="A"/>を大きくしていくとき、この外力を受けた非線形な振り子はどのように振る舞うだろうか。運動の(安定と不安定)固定点に主に興味があるので、外力の周期Tごとに位相空間に点をプロットして、運動の解析を行うのがよい。位相空間におけるそのような図はポアンカレ(Poincare)・プロットと呼ばれている。したがって、<img class="math" src="../_images/math/9ccf6f84261ae88ba38d88676f148d93362478cb.png" alt="n=1,2,3\cdots"/>として、<img class="math" src="../_images/math/3f0936fc27989ba66aa7e36b948a1942fe26e546.png" alt="t=n\mathrm{T}"/>で<img class="math" src="../_images/math/95206fb454a4971f19833766d3cde8d65c9683a2.png" alt="d\theta/ dt"/>を<img class="math" src="../_images/math/a9cfbeb8ebee1f365919e147a79e242dcb67ee5d.png" alt="\theta"/>に対してプロットする。系の周期がTの時にはポアンカレ・プロットは単一の点からなり、周期が<img class="math" src="../_images/math/2ec274a249f41958bf5ac063f4e8119e49820bc4.png" alt="m\mathrm{T}"/>のときには<img class="math" src="../_images/math/c4bb40dd65eae6c11b325989b14e0b8d35e4e3ef.png" alt="m"/>個の点からなる。</p>
</div>
<div class="section" id="id3">
<h2><a class="toc-backref" href="#id9">作成したプログラム</a><a class="headerlink" href="#id3" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>Pythonを用いて作成したプログラムを以下に示す。</p>
<ul class="simple">
<li>パラメータの設定ダイアログ( <a class="reference download internal" href="../_downloads/SetParameter1.py"><tt class="xref download docutils literal"><span class="pre">SetParameter.py</span></tt></a> )</li>
</ul>
<p>以前まで使用していたものを改良してある。show_setting_windowに渡す引数は、パラメータの名前とデフォルト値をセットにして辞書にしたもののリストと、ボタンに表示するテキストをキーとし、コマンドをその値とした辞書である。これによって更に拡張した使い方ができるようになった。</p>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#! /usr/bin/env python </span>
<span class="c"># -*- coding: utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, Mqy 2014.</span>

<span class="kn">from</span> <span class="nn">Tkinter</span> <span class="kn">import</span> <span class="o">*</span>

<span class="k">class</span> <span class="nc">SetParameter</span><span class="p">():</span>

    <span class="k">def</span> <span class="nf">show_setting_window</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">parameters</span><span class="p">,</span> <span class="n">commands</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Show a parameter setting window.</span>
<span class="sd">                </span>
<span class="sd">        parameters: A list of dictionaries {&#39;parameter name&#39;:default_value}</span>
<span class="sd">        commands: A dictionary {&#39;name of button&#39;: command}</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span> <span class="o">=</span> <span class="n">Tk</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s">&#39;Control Widget&#39;</span><span class="p">)</span>
        
        <span class="n">frame1</span> <span class="o">=</span> <span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        <span class="n">frame1</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s">&#39;top&#39;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">entry</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">parameter</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">parameters</span><span class="p">):</span>
            <span class="n">label</span> <span class="o">=</span> <span class="n">Label</span><span class="p">(</span><span class="n">frame1</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="n">parameter</span><span class="o">.</span><span class="n">items</span><span class="p">()[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="s">&#39; = &#39;</span><span class="p">)</span>
            <span class="n">label</span><span class="o">.</span><span class="n">grid</span><span class="p">(</span><span class="n">row</span><span class="o">=</span><span class="n">i</span><span class="p">,</span> <span class="n">column</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">sticky</span><span class="o">=</span><span class="n">E</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Entry</span><span class="p">(</span><span class="n">frame1</span><span class="p">,</span> <span class="n">width</span><span class="o">=</span><span class="mi">10</span><span class="p">))</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">grid</span><span class="p">(</span><span class="n">row</span><span class="o">=</span><span class="n">i</span><span class="p">,</span> <span class="n">column</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">delete</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">END</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">parameter</span><span class="o">.</span><span class="n">items</span><span class="p">()[</span><span class="mi">0</span><span class="p">][</span><span class="mi">1</span><span class="p">])</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">focus_set</span><span class="p">()</span>
       
        <span class="n">frame2</span> <span class="o">=</span> <span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        <span class="n">frame2</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s">&#39;bottom&#39;</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">name</span><span class="p">,</span> <span class="n">command</span> <span class="ow">in</span> <span class="n">commands</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="n">button</span> <span class="o">=</span> <span class="n">Button</span><span class="p">(</span><span class="n">frame2</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="n">name</span><span class="p">,</span> <span class="n">command</span><span class="o">=</span><span class="n">command</span><span class="p">)</span>
            <span class="n">button</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s">&#39;left&#39;</span><span class="p">,</span> <span class="n">fill</span><span class="o">=</span><span class="s">&#39;x&#39;</span><span class="p">)</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="o">.</span><span class="n">mainloop</span><span class="p">()</span>
       
    <span class="k">def</span> <span class="nf">quit</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="o">.</span><span class="n">destroy</span><span class="p">()</span>
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li>4次のルンゲクッタ法で1ステップの計算を行うプログラム( <a class="reference download internal" href="../_downloads/runge_kutta.py"><tt class="xref download docutils literal"><span class="pre">runge_kutta.py</span></tt></a> )</li>
</ul>
<p>4次のルンゲクッタ法を用いて、tの時の値yをもとにt+hのときの値を返すプログラムとなっている。引数として渡す関数と可変長の変数yを変えれば、一般に用いることのできるモジュールとなっている。</p>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#! /usr/bin/env python</span>
<span class="c"># -*- coding: utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>

<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>

<span class="k">class</span> <span class="nc">RK4</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
    
    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">function</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Initialize function.&quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">function</span> <span class="o">=</span> <span class="n">function</span>

    <span class="k">def</span> <span class="nf">solve</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">t</span><span class="p">,</span> <span class="n">h</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Solve the system ODEs.</span>
<span class="sd">        </span>
<span class="sd">        --- arguments ---</span>
<span class="sd">        y: A list of initial values</span>
<span class="sd">        t: Time (float)</span>
<span class="sd">        h: Stepsize (float)</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">f</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">function</span>
        
        <span class="n">k1</span> <span class="o">=</span> <span class="n">h</span> <span class="o">*</span> <span class="n">f</span><span class="p">(</span><span class="n">t</span><span class="p">,</span> <span class="o">*</span><span class="n">y</span><span class="p">)</span>
        <span class="n">k2</span> <span class="o">=</span> <span class="n">h</span> <span class="o">*</span> <span class="n">f</span><span class="p">(</span><span class="n">t</span><span class="o">+</span><span class="mf">0.5</span><span class="o">*</span><span class="n">h</span><span class="p">,</span> <span class="o">*</span><span class="p">[</span><span class="n">y</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">+</span><span class="mf">0.5</span><span class="o">*</span><span class="n">h</span><span class="o">*</span><span class="n">k1</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">y</span><span class="p">))])</span>
        <span class="n">k3</span> <span class="o">=</span> <span class="n">h</span> <span class="o">*</span> <span class="n">f</span><span class="p">(</span><span class="n">t</span><span class="o">+</span><span class="mf">0.5</span><span class="o">*</span><span class="n">h</span><span class="p">,</span> <span class="o">*</span><span class="p">[</span><span class="n">y</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">+</span><span class="mf">0.5</span><span class="o">*</span><span class="n">h</span><span class="o">*</span><span class="n">k2</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">y</span><span class="p">))])</span>
        <span class="n">k4</span> <span class="o">=</span> <span class="n">h</span> <span class="o">*</span> <span class="n">f</span><span class="p">(</span><span class="n">t</span><span class="o">+</span><span class="mf">1.0</span><span class="o">*</span><span class="n">h</span><span class="p">,</span> <span class="o">*</span><span class="p">[</span><span class="n">y</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">+</span><span class="mf">0.5</span><span class="o">*</span><span class="n">h</span><span class="o">*</span><span class="n">k3</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">y</span><span class="p">))])</span>
        
        <span class="n">y</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">y</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">+</span> <span class="p">(</span><span class="n">k1</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">+</span><span class="mi">2</span><span class="o">*</span><span class="n">k2</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">+</span><span class="mi">2</span><span class="o">*</span><span class="n">k3</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">+</span><span class="n">k4</span><span class="p">[</span><span class="n">i</span><span class="p">])</span><span class="o">/</span><span class="mf">6.0</span> 
                     <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">y</span><span class="p">))</span>
                    <span class="p">])</span>
        <span class="k">return</span> <span class="n">y</span>
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li>課題aの実行プログラム( <a class="reference download internal" href="../_downloads/6-14_poincare_a.py"><tt class="xref download docutils literal"><span class="pre">6-14_poincare_a.py</span></tt></a> )</li>
</ul>
<p>課題aで用いたプログラムで、外力の周期Tごとに<img class="math" src="../_images/math/95206fb454a4971f19833766d3cde8d65c9683a2.png" alt="d\theta/ dt"/>を<img class="math" src="../_images/math/a9cfbeb8ebee1f365919e147a79e242dcb67ee5d.png" alt="\theta"/>に対してプロットする。アニメーションで表示させるためにplt.ion()でpyplotのインタラクティブモードをオンにしている。しかし、そのままにすると最後のプロットが終了した時点でウィンドウが閉じてしまうので、最後のプロットでインタラクティブモードをオフにするようにした。</p>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#! /usr/bin/env python</span>
<span class="c"># -*- coding: utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>
<span class="sd">&quot;&quot;&quot;外力を受けた減衰振り子のシミュレーション</span>
<span class="sd">外力の周期ごとにθ-dθ/dtのプロットを表示する。</span>
<span class="sd">初めのntransient回の計算結果は表示しない。</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">from</span> <span class="nn">math</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">matplotlib.pylab</span> <span class="kn">as</span> <span class="nn">plt</span>
<span class="kn">import</span> <span class="nn">SetParameter</span> <span class="kn">as</span> <span class="nn">sp</span>
<span class="kn">import</span> <span class="nn">runge_kutta</span> <span class="kn">as</span> <span class="nn">RK</span>

<span class="c"># --- parameters ---</span>
<span class="n">omega0</span> <span class="o">=</span> <span class="mi">1</span>
<span class="n">omega</span> <span class="o">=</span> <span class="mi">2</span>
<span class="n">T</span> <span class="o">=</span> <span class="n">pi</span>                 <span class="c"># &lt;-- (2*pi)/omega (time period)</span>
<span class="n">nstep</span> <span class="o">=</span> <span class="mi">1000</span> 
<span class="n">dt</span> <span class="o">=</span> <span class="n">T</span><span class="o">/</span><span class="n">nstep</span>           <span class="c"># stepsize in a time period</span>
<span class="n">ntransient</span> <span class="o">=</span> <span class="mi">100</span>
<span class="n">nplot</span> <span class="o">=</span> <span class="mi">100</span>
<span class="n">nmax</span> <span class="o">=</span> <span class="n">ntransient</span> <span class="o">+</span> <span class="n">nplot</span>

<span class="k">def</span> <span class="nf">assignment</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot; Assign the values to variables.&quot;&quot;&quot;</span>
    <span class="k">global</span> <span class="n">theta</span><span class="p">,</span> <span class="n">ang_vel</span><span class="p">,</span> <span class="n">gamma</span><span class="p">,</span> <span class="n">A</span>
    <span class="n">theta</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">window</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">ang_vel</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">window</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">gamma</span>  <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">window</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">A</span>  <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">window</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">window</span><span class="o">.</span><span class="n">quit</span><span class="p">()</span>
    <span class="n">plot</span><span class="p">(</span><span class="n">y</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">theta</span><span class="p">,</span> <span class="n">ang_vel</span><span class="p">]),</span> <span class="n">function</span><span class="o">=</span><span class="n">force</span><span class="p">)</span>
    
<span class="k">def</span> <span class="nf">force</span><span class="p">(</span><span class="n">t</span><span class="p">,</span> <span class="o">*</span><span class="n">y</span><span class="p">):</span>
    <span class="n">theta</span> <span class="o">=</span> <span class="n">y</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
    <span class="n">ang_vel</span> <span class="o">=</span> <span class="n">y</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">ang_vel</span><span class="p">,</span> 
                   <span class="o">-</span><span class="n">gamma</span><span class="o">*</span><span class="n">ang_vel</span> <span class="o">-</span> <span class="p">(</span><span class="n">omega0</span><span class="o">**</span><span class="mi">2</span> <span class="o">+</span> <span class="mi">2</span><span class="o">*</span><span class="n">A</span><span class="o">*</span><span class="n">cos</span><span class="p">(</span><span class="n">omega</span><span class="o">*</span><span class="n">t</span><span class="p">))</span><span class="o">*</span><span class="n">sin</span><span class="p">(</span><span class="n">theta</span><span class="p">)</span>
                   <span class="p">])</span>

<span class="k">def</span> <span class="nf">plot</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="n">function</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Show an animation of Poincare plot.</span>
<span class="sd">    </span>
<span class="sd">    --- arguments ---</span>
<span class="sd">    y: A list of initial values</span>
<span class="sd">    function: function which is argument of Runge-Kutta solver  </span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">h</span> <span class="o">=</span> <span class="n">dt</span>
    <span class="n">fig</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">()</span>
    <span class="n">ax</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">111</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">grid</span><span class="p">()</span>
    <span class="n">time_text</span> <span class="o">=</span> <span class="n">ax</span><span class="o">.</span><span class="n">text</span><span class="p">(</span><span class="mf">0.05</span><span class="p">,</span> <span class="mf">0.9</span><span class="p">,</span> <span class="s">&#39;&#39;</span><span class="p">,</span> <span class="n">transform</span><span class="o">=</span><span class="n">ax</span><span class="o">.</span><span class="n">transAxes</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">ion</span><span class="p">()</span>
        
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">nmax</span><span class="o">+</span><span class="mi">1</span><span class="p">):</span>
        <span class="k">for</span> <span class="n">j</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">nstep</span><span class="p">):</span>
            <span class="n">rk4</span> <span class="o">=</span> <span class="n">RK</span><span class="o">.</span><span class="n">RK4</span><span class="p">(</span><span class="n">function</span><span class="p">)</span>
            <span class="n">y</span> <span class="o">=</span> <span class="n">rk4</span><span class="o">.</span><span class="n">solve</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="n">j</span><span class="o">*</span><span class="n">h</span><span class="p">,</span> <span class="n">h</span><span class="p">)</span>
            <span class="c"># -pi &lt;= theta &lt;= pi </span>
            <span class="k">while</span> <span class="n">y</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">&gt;</span> <span class="n">pi</span><span class="p">:</span>
                <span class="n">y</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">=</span> <span class="n">y</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">-</span> <span class="mi">2</span><span class="o">*</span><span class="n">pi</span>
            <span class="k">while</span> <span class="n">y</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">&lt;</span> <span class="o">-</span><span class="n">pi</span><span class="p">:</span>
                <span class="n">y</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">=</span> <span class="n">y</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="mi">2</span><span class="o">*</span><span class="n">pi</span>
            
        <span class="k">if</span> <span class="n">ntransient</span> <span class="o">&lt;=</span> <span class="n">i</span> <span class="o">&lt;</span> <span class="n">nmax</span><span class="p">:</span>          <span class="c"># &lt;-- draw the poincare plots</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="n">y</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">y</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span> <span class="n">s</span><span class="o">=</span><span class="mf">2.0</span><span class="p">,</span> <span class="n">marker</span><span class="o">=</span><span class="s">&#39;o&#39;</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s">&#39;blue&#39;</span><span class="p">)</span>
            <span class="n">time_text</span><span class="o">.</span><span class="n">set_text</span><span class="p">(</span><span class="s">&#39;n = </span><span class="si">%d</span><span class="s">&#39;</span><span class="o">%</span><span class="n">i</span><span class="p">)</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">draw</span><span class="p">()</span>
            
        <span class="k">if</span> <span class="n">i</span> <span class="o">==</span> <span class="n">nmax</span><span class="p">:</span>                       <span class="c"># &lt;-- to stop the interactive mode</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">ioff</span><span class="p">()</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="n">y</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">y</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span> <span class="n">s</span><span class="o">=</span><span class="mf">2.0</span><span class="p">,</span> <span class="n">marker</span><span class="o">=</span><span class="s">&#39;o&#39;</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s">&#39;blue&#39;</span><span class="p">)</span>
            <span class="n">time_text</span><span class="o">.</span><span class="n">set_text</span><span class="p">(</span><span class="s">&#39;n = </span><span class="si">%d</span><span class="s">&#39;</span><span class="o">%</span><span class="n">i</span><span class="p">)</span>                
            <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
        
<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&#39;__main__&#39;</span><span class="p">:</span>
    
    <span class="n">default_params</span> <span class="o">=</span> <span class="p">[{</span><span class="s">&#39;theta&#39;</span><span class="p">:</span><span class="mf">0.3</span><span class="p">},{</span><span class="s">&#39;ang_vel&#39;</span><span class="p">:</span><span class="mf">0.0</span><span class="p">},{</span><span class="s">&#39;gamma&#39;</span><span class="p">:</span><span class="mf">0.2</span><span class="p">},{</span><span class="s">&#39;A&#39;</span><span class="p">:</span><span class="mf">0.85</span><span class="p">}]</span>

    <span class="n">window</span> <span class="o">=</span> <span class="n">sp</span><span class="o">.</span><span class="n">SetParameter</span><span class="p">()</span>
    <span class="n">window</span><span class="o">.</span><span class="n">show_setting_window</span><span class="p">(</span><span class="n">default_params</span><span class="p">,</span> <span class="p">{</span><span class="s">&#39;Run!&#39;</span><span class="p">:</span> <span class="n">assignment</span><span class="p">})</span>
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li>課題bの実行プログラム( <a class="reference download internal" href="../_downloads/6-14_poincare_b.py"><tt class="xref download docutils literal"><span class="pre">6-14_poincare_b.py</span></tt></a> )</li>
</ul>
<p>課題bで用いたプログラムで、<img class="math" src="../_images/math/a9cfbeb8ebee1f365919e147a79e242dcb67ee5d.png" alt="\theta"/>と<img class="math" src="../_images/math/b6c281b9ec500d7d2764cc0165e0ae4afcc638fc.png" alt="d\theta /dt"/>を<img class="math" src="../_images/math/ef9270877405055756d345facd044e4ab297f858.png" alt="t"/>の関数としてプロットする。同時に表示させるためにsubplotを利用している。また、aとは異なり、すべての演算を終えてから一度に表示させるようにしてある。</p>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#! /usr/bin/env python</span>
<span class="c"># -*- coding: utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>
<span class="sd">&quot;&quot;&quot;外力を受けた減衰振り子のシミュレーション</span>
<span class="sd">θとdθ/dtをtの関数としてプロットする。</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">from</span> <span class="nn">math</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">matplotlib.pylab</span> <span class="kn">as</span> <span class="nn">plt</span>
<span class="kn">import</span> <span class="nn">SetParameter</span> <span class="kn">as</span> <span class="nn">sp</span>
<span class="kn">import</span> <span class="nn">runge_kutta</span> <span class="kn">as</span> <span class="nn">RK</span>

<span class="c"># --- parameters ---</span>
<span class="n">omega0</span> <span class="o">=</span> <span class="mi">1</span> 
<span class="n">omega</span> <span class="o">=</span> <span class="mi">2</span>
<span class="n">T</span> <span class="o">=</span> <span class="n">pi</span>                  <span class="c"># &lt;-- (2*pi)/omega (time period)</span>
<span class="n">tmax</span> <span class="o">=</span> <span class="mf">20.</span><span class="o">*</span><span class="n">T</span>
<span class="n">dt</span> <span class="o">=</span> <span class="mf">0.1</span>                <span class="c"># stepsize in a time period</span>

<span class="k">def</span> <span class="nf">assignment</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot; Assign the values to variables.&quot;&quot;&quot;</span>
    <span class="k">global</span> <span class="n">theta</span><span class="p">,</span> <span class="n">ang_vel</span><span class="p">,</span> <span class="n">gamma</span><span class="p">,</span> <span class="n">A</span>
    <span class="n">theta</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">window</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">ang_vel</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">window</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">gamma</span>  <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">window</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">A</span>  <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">window</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">window</span><span class="o">.</span><span class="n">quit</span><span class="p">()</span>
    <span class="n">plot</span><span class="p">(</span><span class="n">function</span><span class="o">=</span><span class="n">force</span><span class="p">)</span>
       
<span class="k">def</span> <span class="nf">force</span><span class="p">(</span><span class="n">t</span><span class="p">,</span> <span class="o">*</span><span class="n">y</span><span class="p">):</span>
    <span class="n">theta</span> <span class="o">=</span> <span class="n">y</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
    <span class="n">ang_vel</span> <span class="o">=</span> <span class="n">y</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">ang_vel</span><span class="p">,</span> 
                   <span class="o">-</span><span class="n">gamma</span><span class="o">*</span><span class="n">ang_vel</span> <span class="o">-</span> <span class="p">(</span><span class="n">omega0</span><span class="o">**</span><span class="mi">2</span> <span class="o">+</span> <span class="mi">2</span><span class="o">*</span><span class="n">A</span><span class="o">*</span><span class="n">cos</span><span class="p">(</span><span class="n">omega</span><span class="o">*</span><span class="n">t</span><span class="p">))</span><span class="o">*</span><span class="n">sin</span><span class="p">(</span><span class="n">theta</span><span class="p">)</span>
                   <span class="p">])</span>

<span class="k">def</span> <span class="nf">plot</span><span class="p">(</span><span class="n">function</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Show an animation of Poincare plot.</span>
<span class="sd">    </span>
<span class="sd">    --- arguments ---</span>
<span class="sd">    y: A list of initial values</span>
<span class="sd">    function: function which is argument of Runge-Kutta solver  </span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">y</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">theta</span><span class="p">,</span> <span class="n">ang_vel</span><span class="p">])</span>
    <span class="n">h</span> <span class="o">=</span> <span class="n">dt</span>
    <span class="n">rk4</span> <span class="o">=</span> <span class="n">RK</span><span class="o">.</span><span class="n">RK4</span><span class="p">(</span><span class="n">function</span><span class="p">)</span>

    <span class="k">def</span> <span class="nf">calc</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="n">t</span><span class="p">,</span> <span class="n">h</span><span class="p">):</span>
        <span class="n">y</span> <span class="o">=</span> <span class="n">rk4</span><span class="o">.</span><span class="n">solve</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="n">t</span><span class="p">,</span> <span class="n">h</span><span class="p">)</span>
        <span class="c"># -pi &lt;= theta &lt;= pi </span>
        <span class="k">while</span> <span class="n">y</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">&gt;</span> <span class="n">pi</span><span class="p">:</span>
            <span class="n">y</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">=</span> <span class="n">y</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">-</span> <span class="mi">2</span><span class="o">*</span><span class="n">pi</span>
        <span class="k">while</span> <span class="n">y</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">&lt;</span> <span class="o">-</span><span class="n">pi</span><span class="p">:</span>
            <span class="n">y</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">=</span> <span class="n">y</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="mi">2</span><span class="o">*</span><span class="n">pi</span>
        <span class="k">return</span> <span class="n">y</span>
    
    <span class="n">t</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">arange</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">tmax</span><span class="p">,</span> <span class="n">dt</span><span class="p">)</span>
    <span class="n">res_theta</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">t</span><span class="p">),</span> <span class="n">np</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span>
    <span class="n">res_ang_vel</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">t</span><span class="p">),</span> <span class="n">np</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span>

    <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">_t</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">t</span><span class="p">):</span>
        <span class="n">res_theta</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">y</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
        <span class="n">res_ang_vel</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">y</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
        <span class="n">y</span> <span class="o">=</span> <span class="n">calc</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="n">_t</span><span class="p">,</span> <span class="n">h</span><span class="p">)</span>
    
    <span class="n">fig</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">()</span>
    <span class="n">fig</span><span class="o">.</span><span class="n">subplots_adjust</span><span class="p">(</span><span class="n">hspace</span><span class="o">=</span><span class="mf">0.4</span><span class="p">)</span>
    
    <span class="n">ax1</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">211</span><span class="p">)</span>
    <span class="n">ax1</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">t</span><span class="p">,</span> <span class="n">res_theta</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s">r&#39;$\theta$&#39;</span><span class="p">)</span>
    <span class="n">ax1</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">tmax</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s">r&#39;$t$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s">r&#39;$\theta$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s">r&#39;$t\ -\ \theta$&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">loc</span><span class="o">=</span><span class="s">&quot;best&quot;</span><span class="p">)</span>
    
    <span class="n">ax2</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">212</span><span class="p">)</span>
    <span class="n">ax2</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">t</span><span class="p">,</span> <span class="n">res_ang_vel</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s">r&#39;$d\theta /dt$&#39;</span><span class="p">)</span>
    <span class="n">ax2</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">tmax</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s">r&#39;$t$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s">r&#39;$d\theta /dt$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s">r&#39;$t\ -\ d\theta /dt$&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">loc</span><span class="o">=</span><span class="s">&quot;best&quot;</span><span class="p">)</span>
    
    <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>

<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&#39;__main__&#39;</span><span class="p">:</span>
    
    <span class="n">default_params</span> <span class="o">=</span> <span class="p">[{</span><span class="s">&#39;theta&#39;</span><span class="p">:</span><span class="mf">0.3</span><span class="p">},{</span><span class="s">&#39;ang_vel&#39;</span><span class="p">:</span><span class="mf">0.0</span><span class="p">},{</span><span class="s">&#39;gamma&#39;</span><span class="p">:</span><span class="mf">0.2</span><span class="p">},{</span><span class="s">&#39;A&#39;</span><span class="p">:</span><span class="mf">0.85</span><span class="p">}]</span>

    <span class="n">window</span> <span class="o">=</span> <span class="n">sp</span><span class="o">.</span><span class="n">SetParameter</span><span class="p">()</span>
    <span class="n">window</span><span class="o">.</span><span class="n">show_setting_window</span><span class="p">(</span><span class="n">default_params</span><span class="p">,</span> <span class="p">{</span><span class="s">&#39;Run!&#39;</span><span class="p">:</span> <span class="n">assignment</span><span class="p">})</span>
</pre></div>
</td></tr></table></div>
</div>
<div class="section" id="id4">
<h2><a class="toc-backref" href="#id10">実習課題</a><a class="headerlink" href="#id4" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ol class="loweralpha simple">
<li>外力を受けた単純減衰振り子のシミュレーションを行え。プログラムでは、外力の周期Tが<img class="math" src="../_images/math/c1bd4cb4e3647c6b2356b7ccf2f52aeffedd1b61.png" alt="\pi"/>に等しくなるように<img class="math" src="../_images/math/e07549e710dde57193c155bc6e3d166d13fcba70.png" alt="\omega=2"/>、また、<img class="math" src="../_images/math/2634fc36b438daaae8612c182329e295cc3b589d.png" alt="\omega_{0}=1"/>を仮定してよい。<img class="math" src="../_images/math/c932a421ba1409365f825ba7cc1352e662735682.png" alt="\gamma=0.2"/>と<img class="math" src="../_images/math/22cbc076914ff90d73511209d6b6b020ad6ed519.png" alt="A=0.85"/>を用いて、位相空間の軌跡を計算せよ。初期の過渡現象の後に、ポアンカレ・プロットには何個の点があるか。このことから振り子の周期はいくらか求めよ。<img class="math" src="../_images/math/a9cfbeb8ebee1f365919e147a79e242dcb67ee5d.png" alt="\theta"/>と<img class="math" src="../_images/math/b6c281b9ec500d7d2764cc0165e0ae4afcc638fc.png" alt="d\theta /dt"/>の初期値を変えてみよ。アトラクタは初期条件に依存しないか。初期の過渡現象を無視することを忘れないこと。</li>
</ol>
<p><img class="math" src="../_images/math/c932a421ba1409365f825ba7cc1352e662735682.png" alt="\gamma=0.2"/>と<img class="math" src="../_images/math/22cbc076914ff90d73511209d6b6b020ad6ed519.png" alt="A=0.85"/>として初期値<img class="math" src="../_images/math/bef1ca4b08ab851eea0212ffaea2e05d4b09eafd.png" alt="\theta=0.3"/>、<img class="math" src="../_images/math/6a459a32694f2784f49408e60f59d2041754d83d.png" alt="d\theta /dt=0"/>として位相空間に外力の周期Tごとに200回計算を行い、うち最後の100回をプロットした。このポアンカレ・プロットを<a class="reference internal" href="#fig-6-14-f1"><em>図１</em></a>に示す。<a class="reference internal" href="#fig-6-14-f1"><em>図１</em></a>にはプロットされている点が2つしかないため、振り子の周期は<img class="math" src="../_images/math/ac6b70bd0daf3847275b58bdedf2495db865db22.png" alt="2\mathrm{T}=2\pi"/>であることがわかる。また、自明なことではあるが、アトラクタの位置は初期条件に依存する。ただし、振り子の周期は、運動の固定点以外であれば変わらない。固定点では周期1である。</p>
<div class="align-center figure" id="fig-6-14-f1">
<a class="reference internal image-reference" href="../_images/figure_12.png"><img alt="../_images/figure_12.png" src="../_images/figure_12.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/c932a421ba1409365f825ba7cc1352e662735682.png" alt="\gamma=0.2"/>、<img class="math" src="../_images/math/22cbc076914ff90d73511209d6b6b020ad6ed519.png" alt="A=0.85"/>としたときのポアンカレ・プロット</p>
</div>
<ol class="loweralpha simple" start="2">
<li><img class="math" src="../_images/math/a9cfbeb8ebee1f365919e147a79e242dcb67ee5d.png" alt="\theta"/>と<img class="math" src="../_images/math/b6c281b9ec500d7d2764cc0165e0ae4afcc638fc.png" alt="d\theta /dt"/>を<img class="math" src="../_images/math/ef9270877405055756d345facd044e4ab297f858.png" alt="t"/>の関数としてプロットせよ。そしてポアンカレ・プロット、位相空間の図、<img class="math" src="../_images/math/a9cfbeb8ebee1f365919e147a79e242dcb67ee5d.png" alt="\theta"/>や<img class="math" src="../_images/math/b6c281b9ec500d7d2764cc0165e0ae4afcc638fc.png" alt="d\theta /dt"/>の<img class="math" src="../_images/math/ef9270877405055756d345facd044e4ab297f858.png" alt="t"/>依存性の関係を定性的に述べよ。</li>
</ol>
<p><img class="math" src="../_images/math/a9cfbeb8ebee1f365919e147a79e242dcb67ee5d.png" alt="\theta"/>と<img class="math" src="../_images/math/b6c281b9ec500d7d2764cc0165e0ae4afcc638fc.png" alt="d\theta /dt"/>を<img class="math" src="../_images/math/ef9270877405055756d345facd044e4ab297f858.png" alt="t"/>の関数としてプロットしたものを<a class="reference internal" href="#fig-6-14-f2"><em>図2</em></a>に示す。<a class="reference internal" href="#fig-6-14-f2"><em>図2</em></a>を見ると、tの大きいところでは<img class="math" src="../_images/math/a9cfbeb8ebee1f365919e147a79e242dcb67ee5d.png" alt="\theta"/>と<img class="math" src="../_images/math/b6c281b9ec500d7d2764cc0165e0ae4afcc638fc.png" alt="d\theta /dt"/>はtに対して周期関数として振舞っていることがわかる。これは先程ポアンカレ・プロットより得られた理解と一致する。</p>
<div class="align-center figure" id="fig-6-14-f2">
<a class="reference internal image-reference" href="../_images/figure_21.png"><img alt="../_images/figure_21.png" src="../_images/figure_21.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/bef1ca4b08ab851eea0212ffaea2e05d4b09eafd.png" alt="\theta=0.3"/>、<img class="math" src="../_images/math/29c79a8a00918ace0ca345db12fd193c6ffd2e81.png" alt="d\theta /dt = 0.0"/>、<img class="math" src="../_images/math/c932a421ba1409365f825ba7cc1352e662735682.png" alt="\gamma=0.2"/>、<img class="math" src="../_images/math/22cbc076914ff90d73511209d6b6b020ad6ed519.png" alt="A=0.85"/>のときの<img class="math" src="../_images/math/865942b6099dd914899e68f4b250609e5cc3bd91.png" alt="t-\theta"/>、<img class="math" src="../_images/math/3e68ede97f6eaaff1c422f31ce191365f8d1f25e.png" alt="t-d\theta /dt"/>のグラフ</p>
</div>
</div>
<div class="section" id="id5">
<h2><a class="toc-backref" href="#id11">まとめ</a><a class="headerlink" href="#id5" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>4次のルンゲクッタ法を用いた計算で、外力を受けた単純減衰振り子のシミュレーションを行うことができた。課題c,d,e,fにあるように、この系は外力の振幅<img class="math" src="../_images/math/0acafa529182e79b4f56165ec677554fba7fcf98.png" alt="A"/>をパラメータとして周期倍化の性質を見ることができる。時間の都合上取り組むことができなかったが、知識として覚えておきたいと思う。</p>
</div>
<div class="section" id="id6">
<h2><a class="toc-backref" href="#id12">参考文献</a><a class="headerlink" href="#id6" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ul class="simple">
<li>ハーベイ・ゴールド,ジャン・トボチニク,石川正勝・宮島佐介訳『計算物理学入門』,ピアソン・エデュケーション, 2000.</li>
</ul>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">問題6.14 - 外力を受けた減衰振り子</a><ul>
<li><a class="reference internal" href="#id2">シミュレーションの目的</a></li>
<li><a class="reference internal" href="#id3">作成したプログラム</a></li>
<li><a class="reference internal" href="#id4">実習課題</a></li>
<li><a class="reference internal" href="#id5">まとめ</a></li>
<li><a class="reference internal" href="#id6">参考文献</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="../6-12_henon/6-12.html"
                        title="前の章へ">問題6.12 - エノン写像</a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="../6-16_standard_map/6-16.html"
                        title="次の章へ">問題6.16 - 標準写像</a></p>
  <h3>このページ</h3>
  <ul class="this-page-menu">
    <li><a href="../_sources/6-14_poincare/6-14.txt"
           rel="nofollow">ソースコードを表示</a></li>
  </ul>
<div id="searchbox" style="display: none">
  <h3>クイック検索</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="検索" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    モジュール、クラス、または関数名を入力してください
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="../6-16_standard_map/6-16.html" title="問題6.16 - 標準写像"
             >次へ</a> |</li>
        <li class="right" >
          <a href="../6-12_henon/6-12.html" title="問題6.12 - エノン写像"
             >前へ</a> |</li>
        <li><a href="../index.html">計算機実習2014</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2014, Shotaro Fujimoto.
      このドキュメントは <a href="http://sphinx-doc.org/">Sphinx</a> 1.2.2 で生成しました。
    </div>
  </body>
</html>